package com.example.repeater;

import android.content.Context;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;

import java.io.BufferedReader;
import java.io.PrintWriter;
import java.net.Socket;

import android.view.View.OnClickListener;

public class MainActivity extends AppCompatActivity implements Runnable,OnClickListener {
    private ListView listview_info;
    private ListView listview_rf;
    private ListView listview_info_set;
    private ListView listview_rf_set;
    /*** WIFI Start***/
    BufferedReader in;      //서버로부터 온 데이터를 읽는다.
    PrintWriter out;        //서버에 데이터를 전송한다.
    TextView textView_status;
    String data;
    public Button button_port,button_control,listView_button,button_set;
    public Context mContext;
    private Socket socket;  //소켓생성
    public boolean Connection_Status = false;
    public boolean isConnection_Status() {
        return Connection_Status;
    }
    public boolean Send_Set =false;
    public boolean isSend_Status() {
        return Send_Set;
    }
    public void isSend_Set(boolean val) {
        Send_Set = val;
    }
    public static int DATA_TEST = 0;
    final private byte info_set = 1;
    final private byte rf_set = 2;
    final private byte not_setting = 0;
    private byte info_rf_status = not_setting;
    public void setConnection_Status(boolean connection_Status) {
        Connection_Status = connection_Status;
        if(Connection_Status){
            Log.d("setConnection_Status", String.valueOf(Connection_Status));
            button_port.setText("Port Close");
        }else{
            Log.d("setConnection_Status", String.valueOf(Connection_Status));
            button_port.setText("Port Open");
        }
    }
    /*** WIFI END***/
    ImageButton imageButton01;
    ImageButton imageButton02;
    public static ListViewAdapter adapter_infor;
    public static ListViewAdapter adapter_rf;
    public static ListViewAdapter adapter_info_set;
    public static ListViewAdapter adapter_rf_set;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Log.d("MainActivity / Oncreate 실행","성공");
        //        listview_info_set.setOnItemClickListener(this);
//        listview_rf_set.setOnItemClickListener(this);
        listView_button = findViewById(R.id.listView_button);
        imageButton01 = findViewById(R.id.imageButton_info);
        imageButton02 = findViewById(R.id.imageButton_rf);
        // Adapter 생성
        adapter_infor = new ListViewAdapter();
        adapter_rf = new ListViewAdapter();
        adapter_info_set = new ListViewAdapter();
        adapter_rf_set = new ListViewAdapter();
        listview_info = findViewById(R.id.listview_info);
        listview_rf = findViewById(R.id.listview_rf);
        listview_info_set = findViewById(R.id.listview_info_set);
        listview_rf_set = findViewById(R.id.listview_rf_set);


        imageButton02 = findViewById(R.id.imageButton_rf);

        button_port = findViewById(R.id.button_port);
        button_control = findViewById(R.id.button_control);
        button_set = findViewById(R.id.button_set);
        textView_status = findViewById(R.id.textView_status);
        new Thread(new Runnable() {
            @Override
            public void run() {
                // runOnUiThread를 추가하고 그 안에 UI작업을 한다.
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {

                    }
                });
            }
        }).start();

        ListView listview;
        // 리스트뷰 참조 및 Adapter달기
        listview = (ListView) findViewById(R.id.listview_info);
        listview.setAdapter(adapter_infor);


        adapter_infor.addItem("firm info.", "0.1Ver", "", "READ");
        adapter_infor.addItem("FPGA Ver.", "0.2Ver", "", "READ");
        adapter_infor.addItem("F/W Ver.", "0.3Ver", "", "READ");
        adapter_infor.addItem("Config No.", "0.4Ver", "", "READ");
        adapter_infor.addItem("Sub Frame No.", "0.5Ver", "", "READ");
        adapter_infor.addItem("CH1 TTG", "0.6Ver", "", "READ");
        adapter_infor.addItem("CH1 RTG", "0.7Ver", "", "READ");
        adapter_infor.addItem("CH2 TTG", "0.8Ver", "", "READ");
        adapter_infor.addItem("CH2 RTG", "0.9Ver", "", "READ");
        adapter_infor.addItem("CH1 Polarity", "1.1Ver", "", "READ");
        adapter_infor.addItem("CH1 Default", "1.2Ver", "", "READ");
        adapter_infor.addItem("CH2 Polarity", "1.1Ver", "", "READ");
        adapter_infor.addItem("CH2 Default", "1.2Ver", "", "READ");
        adapter_infor.addItem("Auto Config", "1.3Ver", "", "READ");

        listview = (ListView) findViewById(R.id.listview_info_set);
        listview.setAdapter(adapter_info_set);
        adapter_info_set.addItem("firm info.", "0.1Ver", "0", "READ");
        adapter_info_set.addItem("FPGA Ver.", "0.2Ver", "0", "READ");
        adapter_info_set.addItem("F/W Ver.", "0.3Ver", "0", "READ");
        adapter_info_set.addItem("Config No.", "0", "0", "EDIT");
        adapter_info_set.addItem("Sub Frame No.", "0", "0", "EDIT");
        adapter_info_set.addItem("CH1 TTG", "0", "0", "EDIT");
        adapter_info_set.addItem("CH1 RTG", "0", "0", "EDIT");
        adapter_info_set.addItem("CH2 TTG", "0", "0", "EDIT");
        adapter_info_set.addItem("CH2 RTG", "0", "0", "EDIT");
        adapter_info_set.addItem("CH1 Polarity", "ON", "0", "BUTTON");
        adapter_info_set.addItem("CH1 Default", "ON", "0", "BUTTON");
        adapter_info_set.addItem("CH2 Polarity", "ON", "0", "BUTTON");
        adapter_info_set.addItem("CH2 Default", "ON", "0", "BUTTON");
        adapter_info_set.addItem("Auto Config", "MANUAL", "0", "BUTTON");
        // 아이템을 [클릭]시의 이벤트 리스너를 등록
/*        listview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                ListView listView = (ListView) parent;

                //Log.d("data"+position+"  OK","성공");
                // TODO 아이템 클릭시에 구현할 내용은 여기에.
                // String item = (String) listView.getItemAtPosition(position);
                String item = Integer.toString(position);
                Toast.makeText(MainActivity.this, item, Toast.LENGTH_LONG).show();
            }
        });*/
        listview = (ListView) findViewById(R.id.listview_rf);
        listview.setAdapter(adapter_rf);
        adapter_rf.addItem("input ATT", "0 Dbm", "0", "READ");
        adapter_rf.addItem("Output ATT", "0 Dbm", "0", "READ");
        adapter_rf.addItem("Input Offset ATT", "0 Dbm", "0", "READ");
        adapter_rf.addItem("Output Offset ATT", "0 Dbm", "0", "READ");
        adapter_rf.addItem("Gain(dB)", "0 dB", "0", "READ");
        adapter_rf.addItem("ALC Level", "0.6Ver", "0", "READ");
        adapter_rf.addItem("PA Enable", "0.7Ver", "0", "READ");
        adapter_rf.addItem("EX PA Enable", "0.8Ver", "0", "READ");
        adapter_rf.addItem("RF PLL Freq", "0.9Ver", "0", "READ");
        adapter_rf.addItem("AGD Level", "1.1Ver", "0", "READ");
        adapter_rf.addItem("ISO Level", "1.2Ver", "0", "READ");
        adapter_rf.addItem("Temperature", "1.3Ver", "0", "READ");

        listview = (ListView) findViewById(R.id.listview_rf_set);
        listview.setAdapter(adapter_rf_set);
        adapter_rf_set.addItem("input ATT", "0", "0", "EDIT2");
        adapter_rf_set.addItem("Output ATT", "0", "0", "EDIT2");
        adapter_rf_set.addItem("Input Offset ATT", "0", "0", "EDIT2");
        adapter_rf_set.addItem("Output Offset ATT", "0", "0", "EDIT2");
        adapter_rf_set.addItem("Gain(dB)", "0", "0", "EDIT2");
        adapter_rf_set.addItem("ALC Level", "0", "0", "EDIT2");
        adapter_rf_set.addItem("PA Enable", "ON", "0", "BUTTON");
        adapter_rf_set.addItem("EX PA Enable", "ON", "0", "BUTTON");
        adapter_rf_set.addItem("RF PLL Freq", "0", "0", "EDIT");
        adapter_rf_set.addItem("AGD Level", "0", "0", "EDIT");
        adapter_rf_set.addItem("ISO Level", "1.2Ver", "0", "READ");
        adapter_rf_set.addItem("Temperature", "1.3Ver", "0", "READ");
        // 아이템을 [클릭]시의 이벤트 리스너를 등록
      /*  listview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                ListView listView = (ListView) parent;

                //Log.d("data"+position+"  OK","성공");
                // TODO 아이템 클릭시에 구현할 내용은 여기에.
               // String item = (String) listView.getItemAtPosition(position);
                String item = Integer.toString(position);
                Toast.makeText(MainActivity.this, item, Toast.LENGTH_LONG).show();
            }
        });

        // 아이템을 [선택]시의 이벤트 리스너를 등록
        listview.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view,
                                       int position, long id) {
                ListView listView = (ListView) parent;
                // TODO 아이템 선택시에 구현할 내용은 여기에.
                String item = (String) listView.getSelectedItem();
                Toast.makeText(MainActivity.this, item, Toast.LENGTH_LONG).show();
            }
            @Override
            public void onNothingSelected(AdapterView<?> parent) {
            }
        });*/

    }
    /* (non-Javadoc)
     * @see android.widget.AdapterView.OnItemClickListener#onItemClick(android.widget.AdapterView, android.view.View, int, long)
     */
    public void onItemClick (AdapterView < ? > parent, View v,int position, long id)
    {
        Log.d("Click Success : " + adapter_info_set.getItemId(0), "성공");
    }
    Runnable start = new RunnableImplements(this);
    Thread T = new Thread(start);
    public void onClick(View view) {
        switch(view.getId()) {
            case R.id.button_port:

                if(button_port.getText() == "Port Close") {
                    setConnection_Status(false);
                    T.interrupt();
                }
                else {
                    // 버튼을 누르는 이벤트 발생, 이벤트 제어문이기 때문에 이벤트 발생 때마다 발동된다. 시스템이 처리하는 부분이 무한루프문에
                    //있더라도 이벤트가 발생하면 자동으로 실행된다.
                    try{
                        setConnection_Status(true);

                        Log.d("Mainactivity.class / run", "isConnection_Status : " + isConnection_Status());


                        T.start();
                        Log.d("Mainactivity.class / run", "button_port : " + isConnection_Status());
                        Log.d("MainActivity / 쓰레드 실행","성공");
                    }catch (Exception e){
                        Log.e("MainActivity / 쓰레드 실행","실패");
                    }
                }
                break;
            case R.id.button_control:
                if(button_control.getText() == "Status") {
                    button_control.setText("Control");
                    textView_status.setText("Status");
                    button_set.setVisibility(view.INVISIBLE);
                    if(listview_info_set.getVisibility() == view.VISIBLE) {
                        listview_info.setVisibility(view.VISIBLE);
                        listview_info_set.setVisibility(view.INVISIBLE);
                        listview_rf.setVisibility(view.INVISIBLE);
                        listview_rf_set.setVisibility(view.INVISIBLE);
                    }else{
                        listview_rf.setVisibility(view.VISIBLE);
                        listview_rf_set.setVisibility(view.INVISIBLE);
                        listview_info.setVisibility(view.INVISIBLE);
                        listview_info_set.setVisibility(view.INVISIBLE);
                    }
                    info_rf_status = not_setting;
                }
                else {
                    button_control.setText("Status");
                    textView_status.setText("Control");
                    button_set.setVisibility(view.VISIBLE);
                    if(listview_info.getVisibility() == view.VISIBLE) {
                        listview_info.setVisibility(view.INVISIBLE);
                        listview_info_set.setVisibility(view.VISIBLE);
                        listview_rf.setVisibility(view.INVISIBLE);
                        listview_rf_set.setVisibility(view.INVISIBLE);
                        info_rf_status = info_set;
                    }else{
                        listview_rf.setVisibility(view.INVISIBLE);
                        listview_rf_set.setVisibility(view.VISIBLE);
                        listview_info.setVisibility(view.INVISIBLE);
                        listview_info_set.setVisibility(view.INVISIBLE);
                        info_rf_status = rf_set;
                    }
                }
                break;
            case R.id.button_set:
                /*Data Send 조건 */
                if(isSend_Status() == true){
                    isSend_Set(false);
                }else{
                    isSend_Set(true);
                }

                break;
            case R.id.imageButton_info:
                if(textView_status.getText() != "Control") {
                    listview_info.setVisibility(view.VISIBLE);
                    listview_rf.setVisibility(view.INVISIBLE);
                    listview_info_set.setVisibility(view.INVISIBLE);
                    listview_rf_set.setVisibility(view.INVISIBLE);
                }else{
                    listview_info.setVisibility(view.INVISIBLE);
                    listview_rf.setVisibility(view.INVISIBLE);
                    listview_rf_set.setVisibility(view.INVISIBLE);
                    listview_info_set.setVisibility(view.VISIBLE);
                    info_rf_status = info_set;
                }
                break;
            case R.id.imageButton_rf:

                if(textView_status.getText() != "Control") {
                    listview_info.setVisibility(view.INVISIBLE);
                    listview_info_set.setVisibility(view.INVISIBLE);
                    listview_rf_set.setVisibility(view.INVISIBLE);

                    listview_rf.setVisibility(view.VISIBLE);
                }else{
                    listview_info.setVisibility(view.INVISIBLE);
                    listview_info_set.setVisibility(view.INVISIBLE);
                    listview_rf_set.setVisibility(view.VISIBLE);
                    listview_rf.setVisibility(view.INVISIBLE);
                    info_rf_status = rf_set;
                }
                break;
        }
    }

    receive Recv_Context = null;
    public void RecvContext_set(receive context){
        this.Recv_Context =context;
    }
    String Prev_RecvStr;

    int sendtest = 0;
    public int Send_Test(){
        return ++sendtest;
    }
    ListViewItem item = new ListViewItem();
    public void ListViewDataSet(int position, final String str){
        new Thread(new Runnable() {
            @Override
            public void run() {
                // runOnUiThread를 추가하고 그 안에 UI작업을 한다.
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        try {
//            adapter_rf.removeItem(11);
                            if(str != Prev_RecvStr) {
                                adapter_rf.setItem("Temperature", str, "", "READ", 11);
                                adapter_rf_set.setItem("Temperature", str, "", "READ", 11);
                                Prev_RecvStr = str;
//                                adapter_rf.notifyDataSetChanged();
//                                adapter_rf_set.notifyDataSetChanged();
                                if(info_rf_status != not_setting) {
                                    if (info_rf_status == info_set) {
                                        info_data_set();
                                    } else {
                                        rf_data_set();
                                    }
                                }
//                                for(int i = 0; i < 12; i++) {
//                                    item = (ListViewItem)adapter_rf_set.getItem(i);
//                                    Log.d("getView", item.getVal() +  "||||||\r\n");
//                                }
//                                Log.d("Mainactivity.class / runOnUiThread", "isConnection_Status : " + isConnection_Status());
                            }
//
                        }catch (Exception e){
                            Log.e("fail to process file", String.valueOf(e));
                            Log.d("ListViewDataSet :  ", "I FAILED PUT DATA TRY 4");
                        }
                    }
                });
            }
        }).start();
    }

    private String info_data_set(){
        String temp_str = "be01";
        for(int i = 3; i < 14; i++) {
            item = (ListViewItem) adapter_info_set.getItem(i);
             temp_str += item.getVal();
        }
        Log.d("Mainactivity.class / info_data_set", temp_str);
        return temp_str;
    }

    private String rf_data_set(){
        String temp_str = "";
        for(int i = 0; i < 10; i++) {
            item = (ListViewItem) adapter_rf_set.getItem(i);
            temp_str += item.getVal();
            if(i < 6) {
                temp_str += item.getVal2();
            }
        }
        Log.d("Mainactivity.class / rf_data_set", temp_str);
        return temp_str;
    }

    @Override
    public void run() {
//        connect con = new connect(this);
//        try {
//            Log.d("YJ TEST ", String.valueOf(DATA_TEST));
//            Log.d("MainActivity / Run 함수 실행", "성공");
//        } catch (Exception e) {
//            Log.e("MainActivity / Run 함수 실행", "실패");
//            //  setConnection_Status(false);
//        }
//        con.run();
    }

}
class RunnableImplements implements Runnable {
    MainActivity mActivity = null;

    public RunnableImplements(MainActivity Activity) {
        this.mActivity = Activity;
    }

    public void run(){
        connect con = new connect(this.mActivity);
        try {
//            Log.d("YJ TEST ", String.valueOf(DATA_TEST));
            Log.d("MainActivity / Run 함수 실행", "성공");
        } catch (Exception e) {
            Log.e("MainActivity / Run 함수 실행", "실패");
            //  setConnection_Status(false);
        }
        con.run();
        // 작업
    }
}